/*
	$Id: Group.java 296 2006-09-07 18:20:59Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import org.w3c.dom.Element;

/**
   饹ޤϥ󥿥եǤ

   classǤޤinterfaceǤδ쥯饹Ǥ
*/
public abstract class Group {

    /** ѥå̾ */
    private String packageName;

    /** ̾ */
    private String name;

    /** ̾ */
    private String nameSpace;

    /** descǤ */
    private Description desc;

    /** ҥΡɥե륿 */
    private ChildrenFilter c;

    /** Υ롼פ֤̾ΰ */
    private Location location;

    /** Υ롼פ˽°뼱̻ҤΥޥå */
    private HashSet<String> names;

    /** ̻ҥޥ͡ */
    private IDManager idManager;

    /** Υ롼פΥե̾ */
    private String sourceFile;

    /**
       롼פޤ

       @param elem classǤޤinterface
       @param filename XMLΥե̾
    */
    protected Group(final Element elem, final String filename) {
        idManager = IDManager.getInstance();
	c = new ChildrenFilter(elem);
	packageName = idManager.getIDAttribute(elem, "package");
	name = idManager.getIDAttribute(elem, "name");
        nameSpace
	    = ((c.getDirectChildrenByTagName("namespace").getLength() > 0)
	       ? packageName + "_" + name + "_" : null);
        desc = new Description(c.getDirectChildrenByTagName("desc"));
	sourceFile = filename;
	location = new Location(packageName, name);
	names = new HashSet<String>();
    }

    /**
       Υ롼פλҥΡɥե륿ޤ

       @return Υ롼פλҥΡɥե륿
    */
    protected ChildrenFilter getChildrenFilter() {
        return c;
    }

    /**
       Υ롼פΥɤϿޤ

       @param s 
    */
    public void addKeyword(final String s) {
	idManager.addKeyword(location, s);
    }

    /**
       Υ롼פΥե̾ޤ

       @return Υ롼פΥե̾
    */
    public String getFilename() {
        return sourceFile;
    }

    /**
       Υ롼פ̾ޤ

       @return Υ롼פ̾
    */
    public String getName() {
        return name;
    }

    /**
       Υ롼פΥѥå̾ޤ

       @return Υ롼פΥѥå̾
    */
    public String getPackageName() {
	return packageName;
    }

    /**
       Υ롼פ̾Ÿλ̵ͭޤ

       @return ̾Ÿλ꤬trueʤfalse
    */
    public boolean isNamespaceExpanded() {
	return nameSpace != null;
    }

    /**
       HTMLޤ

       @return HTML
    */
    public String getBriefDescription() {
        return desc.getBriefText();
    }

    /**
       HTMLޤ

       @return HTML
    */
    public String getDescription() {
        return desc.getText();
    }

    /**
       ꤷǥ쥯ȥΥե˽񤯥饤ޤ

       @param dirName ǥ쥯ȥ̾
       @param fileName ե̾
       @return 饤
    */
    protected PrintWriter createPrintWriter(final String dirName,
					    final String fileName) {
	return Sanctuary.createPrintWriter(dirName, fileName, "UTF-8");
    }

    /**
       Υ롼פΥפޤ

       @return 
    */
    protected abstract String getType();

    /**
       إåեޤ
    */
    public abstract void printCode();

    /**
       HTMLΥɥȤޤ
    */
    public void printHtml() {
	String fileName = packageName + "_" + name + ".html";
	PrintWriter wr = Sanctuary.createPrintWriter(null, fileName, "UTF-8");
	printHtmlHeader(wr, getType());
	printHtml(wr);
	printHtmlFooter(wr);
	wr.close();
    }

    /**
       HTMLեΥإåϤޤ

       @param wr 饤
       @param s "Class" ޤ "Interface"
    */
    private void printHtmlHeader(final PrintWriter wr, final String s) {
	String contentType = "text/html; charset=utf-8";

	wr.println(""
+ "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
+ "<html>\n"
+ "  <head>\n"
+ "    <meta HTTP-EQUIV=\"Content-Type\" CONTENT=\"" + contentType + "\">\n"
+ "    <title>" + packageName + "_" + name + "</title>\n"
+ "    <link rel=\"stylesheet\" type=\"text/css\" href=\"sanctuary.css\">\n"
+ "  </head>\n"
+ "  <body>\n"
+ "    <h3>package " + packageName + "</h3>\n"
+ "    <h1>" + s + " " + name + "</h1>\n"
+ "    <dl><dd>" + getDescription() + "</dd></dl>\n"
+ "    <hr>");
    }

    /**
       HTMLեʸϤޤ

       @param wr 饤
    */
    protected abstract void printHtml(final PrintWriter wr);

    /**
       HTMLեΥեåϤޤ

       @param wr 饤
    */
    private void printHtmlFooter(final PrintWriter wr) {
	wr.println(""
+ "  </body>\n"
+ "</html>");
    }

    /**
       TeXեޤ
    */
    public void printTex() {
	String fileName = packageName + "_" + name + ".tex";
	PrintWriter wr = Sanctuary.createPrintWriter(null, fileName, "EUC-JP");
	String ns = packageName + "." + name;

	wr.print(""
+ "\\S" + getType() + "{" + name + "}\n"
+ "\\Shypertarget{:" + Tex.safeTarget(ns) + ":}{}\n"
+ desc.getTexText() + "\n");
	printTex(wr);
	wr.close();
    }

    /**
       TeXեʸϤޤ

       @param wr 饤
    */
    protected abstract void printTex(PrintWriter wr);

    /**
       ֤Υեޤ
    */
    public abstract void printStub();

    /**
       ݡȥޥϤޤ

       @param wr 饤
    */
    public void printImportMacro(final PrintWriter wr) {
	String longPrefix = location.getPrefix();
	String shortPrefix = location.getShortPrefix();
	String[] sortedNames = names.toArray(new String[0]);
	Arrays.sort(sortedNames);
	for (String s : sortedNames) {
	    String longName = prependPrefix(longPrefix, s);
	    String shortName = prependPrefix(shortPrefix, s);
	    wr.println("#define " + shortName + " " + longName);
	}
    }

    /**
       ʸ˥ץեå֤ޤ

       @param prefix ץեå
       @param s ʸ
       @return s "@" ξ prefixʳξ prefix + "_"
       + s
    */
    private String prependPrefix(final String prefix, final String s) {
	if (s.equals("@")) {
	    return prefix;
	}
	return prefix + "_" + s;
    }

    /**
       Υ롼פ˽°ؿޤ

       @param elem method
       @return ؿ
    */
    public Method createRegularMethod(final Element elem) {
	RegularMethod m = new RegularMethod(this, elem);
	addKeyword(m.getName());
	return m;
    }

    /**
       ʸ˴ޤޤ@פ򤳤֤̾ɽץեåŸ
       ޤCΥȤ˴ޤޤ@פŸޤ

       CΥȤĤƤʤnull֤ޤ

       @param s ʸ
       @return Ÿʸ
    */
    private String expandATString(final String s) {
	int j;
	String t = s;
	String z = "";

	z = "";
	while (t.length() > 0 && (j = t.indexOf("/*")) != -1) {
	    String u = t.substring(0, j);
	    String v = t.substring(j + 2);
	    int k = v.indexOf("*/");

	    if (k == -1) {
		return null;
	    }
	    z += u.replaceAll("@", location.getPrefix())
		+ "/*" + v.substring(0, k) + "*/";
	    t = v.substring(k + 2);
	}
	return z + t.replaceAll("@", location.getPrefix());
    }

    /**
       Ǥ°ͤ@Ÿ̤ޤ

       @param elem 
       @param attrName °̾
       @return @Ÿ°
    */
    public String expandAT(final Element elem, final String attrName) {
	String s = elem.getAttribute(attrName);
	if (s.equals("")) {
	    String m = "empty value: " + attrName;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	s = expandATString(s);
	if (s == null) {
	    String m = "unterminated comment: " + attrName;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	return s;
    }

    /**
       Ǥ°ͤ򤳤Υ롼פ֤̾Ÿޤ

       ̾Ÿλ꤬: ̻Ҥ@פξϤ̾
       ɽץեåŸޤʳξ硢ץեå
        + "_" + ̻Ҥ֤ޤisImportedtrueξϡŸ
       ̻Ҥ򥤥ݡȥޥȤϿޤ

       ̾Ÿλ꤬ʤ: @Ÿη̤֤ޤ

       @param elem 
       @param attrName °̾
       @param isImported ݡȥޥϿtrue
       @return ̾Ÿޤ@Ÿ°
    */
    public String expandNS(final Element elem, final String attrName,
			   final boolean isImported) {
	String t;
	if (nameSpace == null) {
	    t = expandAT(elem, attrName);
	} else {
	    String s = elem.getAttribute(attrName);
	    if (s.equals("")) {
		String m = "empty value: " + attrName;
		throw new NodeException(elem.getAttributeNode(attrName), m);
	    }
	    if (isImported) {
		names.add(s);
	    }
	    t = prependPrefix(location.getPrefix(), s);
	}
	if (!idManager.isCID(t)) {
	    String m = "invalid identifier: " + t;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	return t;
    }

    /**
       Ǥ°ͤ򤳤Υ롼פ֤̾Ÿޤ

       expandNS(elem, attrName, true)Ʊ̣Ǥ

       @param elem 
       @param attrName °̾
       @return ̾Ÿޤ@Ÿ°
    */
    public String expandNS(final Element elem, final String attrName) {
	return expandNS(elem, attrName, true);
    }

    /**
       ʸ˴ޤޤƤ륿̾򥤥ݡȤ륿ȤϿޤ

       @param s ʸ
    */
    public abstract void importTags(final String s);
}
