/*
	$Id: MethodParameter.java 294 2006-09-06 15:57:45Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ᥽åɤΰǤ

   paramǤбޤ
*/
public class MethodParameter extends Parameter {

    /** type° */
    private String type;

    /** name° */
    private String name;

    /** descǤ */
    private Description desc;

    /**
       ؿΰޤ

       @param g 롼
       @param elem parameter
    */
    public MethodParameter(final Group g, final Element elem) {
	IDManager id = IDManager.getInstance();
	type = g.expandAT(elem, "type");
	name = id.getIDAttribute(elem, "name");
	g.importTags(type);

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       {@inheritDoc}

       type°#ޤޤ硢Ƭ#name°Ƥִ
       Τ֤ޤǤʤСtype°name°Ƥ
       Ϣ뤷Τ֤ޤ
    */
    @Override public String getCode() {
	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", name);
	} else {
	    return type + " " + name;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public String getName() {
	return name;
    }

    /**
       {@inheritDoc}
    */
    @Override public String getText() {
	String argName = "<i>" + name + "</i>";

	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", argName);
	} else {
	    return type + "&nbsp;" + argName;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public String getTexText() {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";
	String texType = Tex.safe(type);

	if (texType.indexOf('#') != -1) {
	    return texType.replaceFirst("#", argName);
	} else {
	    return texType + " " + argName;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public void printDetail(final PrintWriter wr) {
	wr.println(""
+ "<i>" + name + "</i> - " + desc.getText() + "<br>\n");
   }

    /**
       {@inheritDoc}
    */
    @Override public void printTexDetail(final PrintWriter wr) {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";

	wr.println(""
+ "\\item[" + argName + "] " + desc.getTexText());
   }

}
