/*
	$Id: PackageManager.java 253 2006-08-13 14:05:36Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Set;

/**
   ٤ƤΥѥåѥåޥ͡Ǥ
*/
public final class PackageManager {

    /** ͣΥ󥹥 */
    private static PackageManager theInstance;

    /**
       󥹥󥹤ޤ

       @return ѥåޥ͡
    */
    public static PackageManager getInstance() {
        if (theInstance == null) {
            theInstance = new PackageManager();
        }
        return theInstance;
    }

    /**
       ѥå̾򥭡ȤΥѥå˽°륰롼פͤ
       ϥåޥå
    */
    private HashMap<String, ArrayList<Group>> packageHash;

    /**
       ѥå̾򥭡ȤΥѥåξܺ٤ͤȤϥå
       ޥå
    */
    private HashMap<String, Package> packageDescHash;

    /** ٤ƤΥ롼פΥꥹ */
    private ArrayList<Group> allGroups;

    /**
       ѥåޥ͡ޤ
    */
    private PackageManager() {
	packageHash = new HashMap<String, ArrayList<Group>>();
	packageDescHash = new HashMap<String, Package>();
	allGroups = new ArrayList<Group>();
    }

    /**
       ѥåɲäޤ

       @param packageElem ѥå
    */
    public void addPackage(final Package packageElem) {
	String packageName = packageElem.getName();
	packageDescHash.put(packageName, packageElem);
    }

    /**
       롼פɲäޤ

       롼פϥ饹ޤϥ󥿥եǤ

       @param group 롼
    */
    public void addGroup(final Group group) {
	String packageName = group.getPackageName();
	ArrayList<Group> v = packageHash.get(packageName);
	if (v == null) {
	    v = new ArrayList<Group>();
	    packageHash.put(packageName, v);
	}
	v.add(group);
	allGroups.add(group);
    }

    /**
       ꤷ̾ΥѥåHTMLǽϤޤ

       ѥå³°륰롼פΰޤ

       @param wr 饤
       @param packageName ѥå̾
    */
    private void printGroups(final PrintWriter wr, final String packageName) {
	Package p = packageDescHash.get(packageName);
	if (p != null) {
	    String s = p.getDescription();
	    if (s != null) {
		wr.println(s);
	    }
	}
	wr.println("<h2>Class Summary</h2>");

	ArrayList<Group> v = packageHash.get(packageName);
	Group[] g = v.toArray(new Group[0]);
	Arrays.sort(g, new Comparator<Group>() {
	    public int compare(final Group g1, final Group g2) {
		return g1.getName().compareTo(g2.getName());
	    }
	});
	for (Group group : g) {
	    String name = group.getName();
	    String pre = "";
	    String post = "";
	    if (group instanceof Interface) {
		pre = "<i>";
		post = "</i>";
	    }
	    wr.println(""
+ "<dl><dt><a href=\"" + packageName + "_" + name + ".html\">"
+ pre + name + post + "</a></dt><dd>\n"
+ group.getBriefDescription() + "</dd></dl>");
	}
    }

    /**
       ٤ƤΥѥåHTMLǽϤޤ

       @param wr 饤
    */
    private void printAllPackages(final PrintWriter wr) {
	Set<String> s = packageHash.keySet();
	String[] p = s.toArray(new String[0]);
	Arrays.sort(p);
	for (String packageName : p) {
	    wr.println("<a name='" + packageName + "'></a>");
	    wr.println("<h1>Package " + packageName + "</h1>");
	    printGroups(wr, packageName);
	    wr.println("<hr>");
	}
    }

    /**
       ٤ƤΥ롼פHTMLǽϤޤ

       @param wr 饤
    */
    private void printAllGroups(final PrintWriter wr) {
	Group[] g = allGroups.toArray(new Group[0]);
	Arrays.sort(g, new Comparator<Group>() {
	    public int compare(final Group g1, final Group g2) {
		int s = g1.getName().compareTo(g2.getName());
		if (s != 0) {
		    return s;
		}
		return g1.getPackageName().compareTo(g2.getPackageName());
	    }
	});
	for (int k = 0; k < g.length; ++k) {
	    Group group = g[k];
	    String packageName = group.getPackageName();
	    String name = group.getName();
	    String pre = "";
	    String post = "";
	    if (group instanceof Interface) {
		pre = "<i>";
		post = "</i>";
	    }
	    wr.println(""
+ "<a href=\"" + packageName + "_" + name + ".html\">"
+ pre + name + post + "</a><br>");
	}
    }

    /**
       ٤ƤΥ롼פΥꥹȤޤ

       @return ٤ƤΥ롼פΥꥹ
    */
    public List<Group> groupList() {
	return allGroups;
    }

    /**
       index.htmlϤޤ
    */
    public void printIndexHtml() {
	PrintWriter wr = Sanctuary.createPrintWriter(null, "index.html",
						     "UTF-8");
	String contentType = "text/html; charset=utf-8";

	wr.println(""
+ "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
+ "<html>\n"
+ "  <head>\n"
+ "    <meta HTTP-EQUIV=\"Content-Type\" CONTENT=\"" + contentType + "\">\n"
+ "    <title>API Reference</title>\n"
+ "    <link rel=\"stylesheet\" type=\"text/css\" href=\"sanctuary.css\">\n"
+ "  </head>\n"
+ "  <body>\n"
+ "    <table width=\"100%\">\n"
+ "      <tr>\n"
+ "        <td nowrap valign=\"top\" width=\"1%\">\n"
+ "          <font size=\"-1\"><b>All Classes</b><br>");
	printAllGroups(wr);
	wr.println(""
+ "          </font>\n"
+ "        </td>\n"
+ "        <td>&nbsp;</td>\n"
+ "        <td>");
	printAllPackages(wr);
	wr.println(""
+ "        </td>\n"
+ "      </tr>\n"
+ "    </table>\n"
+ "  </body>\n"
+ "</html>");
	wr.close();
    }

    /**
       ѥåȤ˴ޤޤ륰롼TeǽϤޤ

       @param wr 饤
       @param packageName ѥå̾
    */
    private void printTexPackage(final PrintWriter wr,
				 final String packageName) {
	wr.println("\\Spackage{" + Tex.safe(packageName) + "}");
	wr.println("\\Shypertarget{:"
		   + Tex.safeTarget(packageName)
		   + ":}{}");
	Package p = packageDescHash.get(packageName);
	if (p != null) {
	    String s = p.getTexDescription();
	    if (s != null) {
		wr.println(s);
	    }
	}
	ArrayList<Group> v = packageHash.get(packageName);
	Group[] g = v.toArray(new Group[0]);
	Arrays.sort(g, new Comparator<Group>() {
	    public int compare(final Group g1, final Group g2) {
		return g1.getName().compareTo(g2.getName());
	    }
	});
	for (Group group : g) {
	    String name = packageName + "_" + group.getName();
	    wr.println("\\input{" + name + ".tex}");
	}
    }

    /**
       sanctuary.texϤޤ
    */
    public void printSanctuaryTex() {
	PrintWriter wr
	    = Sanctuary.createPrintWriter(null, "sanctuary.tex", "EUC-JP");
	Set<String> set = packageHash.keySet();
	String[] p = set.toArray(new String[0]);
	Arrays.sort(p);
	for (String packageName : p) {
	    printTexPackage(wr, packageName);
	}
	wr.close();
    }
}
